

#include "MBR.h"
#include "data_struct.h"



int odc_pruning( rect_t* r_a, rect_t* r_b, rect_t* r_q, int p)
{
	int i, dim;
	COORD_TYPE x;
	DIST_TYPE dist, d_1, d_2;

	dim = r_a->dim;
	dist = 0;
	for( i=0; i<dim; i++)
	{
		x = r_q->axis[ i].min;
		d_1 = calc_max_diff_lp( &r_a->axis[ i], x, p) -
				calc_min_diff_lp( &r_b->axis[ i], x, p);

		x = r_q->axis[ i].max;
		d_2 = calc_max_diff_lp( &r_a->axis[ i], x, p) -
				calc_min_diff_lp( &r_b->axis[ i], x, p);

		dist += d_1 >= d_2 ? d_1 : d_2;
	}

	if( dist < 0)
		return 1;
	else
		return 0;
}

rect_t* calc_MBR_sphere( sphere_t* s_v)
{
	int i;
	rect_t* rect_v;

	rect_v = alloc_rect( s_v->center->dim);

	//
	for( i=0; i<rect_v->dim; i++)
	{
		rect_v->axis[ i].min = s_v->center->coord[ i] - ( COORD_TYPE)s_v->radius;
		rect_v->axis[ i].max = s_v->center->coord[ i] + ( COORD_TYPE)s_v->radius;
	}

	return rect_v;
}

int MBR_pruning( sphere_t* s_a, sphere_t* s_b, sphere_t* s_q)
{
	rect_t* r_a, *r_b, *r_q;

	//emp
	dup_point( s_a->center);
	dup_point( s_b->center);
	dup_point( s_q->center);
	//emp

	r_a = calc_MBR_sphere( s_a);
	r_b = calc_MBR_sphere( s_b);
	r_q = calc_MBR_sphere( s_q);
	
	return odc_pruning( r_a, r_b, r_q, 2);
}