

#ifndef MBR_H
#define MBR_H


#include "data_struct.h"
#include "data_utility.h"

#include "hyperbola.h"

/*
 *	The MBR pruning method introduced by T. Emrich et al. [SIGMOD'10].
 *
 *	@p indicates the lp-norm.
 */
int odc_pruning( rect_t* r_a, rect_t* r_b, rect_t* r_q, int p);


/*
 *	Calculate the "MBR" of a hypersphere.
 */
rect_t* calc_MBR_sphere( sphere_t* s_v);

/*
 *	The Hypersphere pruning method based on odc_pruning.
 */
int MBR_pruning( sphere_t* s_a, sphere_t* s_b, sphere_t* s_q);

#endif
