

#ifndef MAXMIN_H
#define MAXMIN_H

#include "data_struct.h"
#include "data_utility.h"

#include "hyperbola.h"


/* 
 *	Calculate the "maximum distance" between two hyperspheres.
 */	
DIST_TYPE calc_max_dist_spheres( sphere_t* s_a, sphere_t* s_b);


/*
 *	Calculate the "minimum distance" between two hyperspheres.
 */
DIST_TYPE calc_min_dist_spheres( sphere_t* s_a, sphere_t* s_b);


/*
 *	The implementation of the MaxMin pruning.
 */
int MaxMin_pruning( sphere_t* s_a, sphere_t* s_b, sphere_t* s_q);

#endif