

#ifndef B_HEAP_H
#define	B_HEAP_H

#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#include <string.h>


//#include "data_struct.h"
//#include "data_utility.h"

#include "sstree.h"


#define		B_CONFIG_FILE		"b_config.txt"
#define		MAX_FILENAME_LENG	256
#define		FLOAT				float

//#define	MIN_HEAP_OPT		0

extern		int	MIN_HEAP_OPT;

/*
#define		B_INPUT_FILE	"b_input.txt"
#define		B_OUTPUT_FILE	"b_output.txt"
*/

//extern emp_stat_t	emp_stat_v;

//The structure of the object that indexed by the binary heap.
typedef	struct h_obj
{
	int		id;
	int		loc;				

	//object-specific variables.
	DIST_TYPE	key;	//The key of the heap. 

	node_t*		node_v;	
	
	point_t*	point_v;

	//
	int		pre;
	int		next;
} h_obj_t;


//The structure of the node of a heap.
typedef	struct b_heap
{
	int			size;			//the heap's size.
	int			rear;			//the heap's rear tag.
	h_obj_t*	obj_arr;		//the object array.
	int*		h_arr;			//the heap array.

	//For empirical study.
	float		m_size;

} b_heap_t;



//-------------------------------------

//int cmp( const void* obj_v, int fir, int sec);

int cmp_min( int* array, int n1, int n2, h_obj_t* obj_v);

int cmp_max( int* array, int n1, int n2, h_obj_t* obj_v);

//-------------------------------------

b_heap_t* alloc_b_heap( int size);

void release_b_heap( b_heap_t* b_h);

void b_t_heapify( int* array, int cur, h_obj_t* obj_v);

void t_b_heapify( int* array, int cur, int rear, h_obj_t* obj_v);

int insert_b_heap( b_heap_t* b_h, int n);

int get_top( b_heap_t* b_h);

void update_key( b_heap_t* b_h, int k);

//-------------------------------------


void print_b_heap( FILE* o_fp, b_heap_t* b_h);

void test_b_heap( );


#endif