

#ifndef BF_H
#define BF_H


#include "data_struct.h"
#include "data_utility.h"
#include "trigonometric.h"

/*
 *	Bruteforce method for pruning based 3 sets of points.
 */
int bruteforce_pruning( point_set_t* ps_a, point_set_t* ps_b, point_set_t* ps_q);

/*
 *	Caclate the "best-fitting-rectangle" of a set of points.
 */
rect_t* calc_best_fitting_rect( point_set_t* point_set_v);

/*
 *	Calculate the "best-fitting-sphere" of a set of points.
 */
sphere_t* calc_best_fitting_sphere( point_set_t* point_set_v);

#endif