
/*
 *	Author: Cheng Long
 *	Email: clong@cse.ust.hk
 */


#include "hyperbola.h"
#include "trigonometric.h"
#include "bf.h"
#include "MBR.h"
#include "MaxMin.h"
//#include "GP.h"

#include "sstree.h"
#include "kNN.h"

IRTree_t SS_Tree_v;
_stat_t	_stat_v;

stat_t stat_v_Dom;
stat_t stat_v_AkNN;
stat_t stat_v_DS;

int	MIN_HEAP_OPT;

/*
 *	Empirically study the pruning techniques on 3 hyperspheres.
 */
void emp_spatial_dom( );


int main( )
{
	MIN_HEAP_OPT = 1;

	//test_SSTree( );
	emp_spatial_dom( );

	return 0;
}

void emp_spatial_dom( )
{
	int i, ins_n;
	//, rtn_1, rtn_2, rtn_3, rtn_4, rtn_5;

	config_t* config_v;
	sphere_data_t* sphere_data_v;

	sphere_t* s_a, *s_b, *s_q;

	//Read the hyperspheres;
	config_v = read_config( );

	sphere_data_v = read_sphere_data( config_v);

	ins_n = 1;
	i = 0;
	//Perform the pruning;
	while( i + 2 < sphere_data_v->sphere_n)
	{
		//
		printf( "instance #%i ...\n", ins_n++);

		//3 hyperspheres;
		s_a = sphere_data_v->sphere_v[ i];
		s_b = sphere_data_v->sphere_v[ i+1];
		s_q = sphere_data_v->sphere_v[ i+2];

		//
		printf( "%i\n", comp_sphere_dom( s_a, s_b, s_q, config_v->dom_tag));

		i+= 3;
	}

	//Release the resources.
	release_sphere_data( sphere_data_v);
	free( config_v);
}