

#ifndef TRIGONOMETRIC_H
#define TRIGONOMETRIC_H

#include "data_struct.h"
#include "data_utility.h"

#include "hyperbola.h"

#define	PRE_CHECK_TAG 0	//

int is_spheres_overlap( sphere_t* sphere_v1, sphere_t* sphere_v2);

int is_points_overlap( point_t* point_v1, point_t* point_v2);

point_t* cons_vector( point_t* point_v1, point_t* point_v2);

DIST_TYPE calc_dot_product( point_t* vector_v1, point_t* vector_v2);

DIST_TYPE calc_length_vector( point_t* vector_v);

double calc_angle_vectors( point_t* vector_v1, point_t* vector_v2);

DIST_TYPE calc_g_function( sphere_t* s_q, sphere_t* s_a, sphere_t* s_b, double phi, double delta);

int is_dists_equal( DIST_TYPE dist_v1, DIST_TYPE dist_v2);

int trigonometric_pruning( sphere_t* s_a, sphere_t* s_b, sphere_t* s_q);

#endif